<?php

/**
 * This project has been generated by nuts generator
 * nuts has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 */


namespace Model;

use Base\BaseModel;
use Handler\DataValidationException;

class AccountbankModel extends BaseModel
{
    protected $table = "accountbank";

    protected $aliasTable = "acbnk";

    protected $primaryKey = "id";
    protected $fillable = ["accountName", "accountNo", "bankId", "createdAt", "currentBalance", "familyId", "updatedAt"];

    public function joinRelationBanks($alias = "banks")
    {
        $this->query->join("banks as $alias", "$alias.id", "=", "acbnk.bankId");
        return $this;
    }

    public function joinRelationFamily($alias = "family")
    {
        $this->query->join("family as $alias", "$alias.id", "=", "acbnk.familyId");
        return $this;
    }


    public function beforeEnterIntoDatabase()
    {
        if (empty($this->bankId)) {
            throw new DataValidationException("bankId cannot be null");
        }
        if (empty($this->familyId)) {
            throw new DataValidationException("familyId cannot be null");
        }
        $Banks = (new \Model\BanksModel)->findById($this->bankId);
        if (empty($Banks)) {
            throw new DataValidationException("bankId Invalid Relation ID");
        }
        $Family = (new \Model\FamilyModel)->findById($this->familyId);
        if (empty($Family)) {
            throw new DataValidationException("familyId Invalid Relation ID");
        }
        return $this;
    }
}